<?php
if ( ! defined( 'ABSPATH' ) ) exit;


function bodycommerce_social_sharing_buttons($sharinglinks) {

  $sharing_icon_style = get_bodycommerce_option( 'sharing_icon_style' );
  $sharing_icon_btn_color = get_bodycommerce_option( 'sharing_icon_btn_color' );
  $sharing_icon_btn_border_radius = get_bodycommerce_option( 'sharing_icon_btn_border_radius' );

  $sharing_icon_twitter = get_bodycommerce_option( 'sharing_icon_twitter' );
  $sharing_icon_facebook = get_bodycommerce_option( 'sharing_icon_facebook' );
  $sharing_icon_instagram = get_bodycommerce_option( 'sharing_icon_instagram' );
  $sharing_icon_linkedin = get_bodycommerce_option( 'sharing_icon_linkedin' );
  $sharing_icon_pinterest = get_bodycommerce_option( 'sharing_icon_pinterest' );
  $sharing_icon_email = get_bodycommerce_option( 'sharing_icon_email' );
  $sharing_icon_email_subject = get_bodycommerce_option( 'sharing_icon_email_subject' );
  $sharing_icon_email_body = get_bodycommerce_option( 'sharing_icon_email_body' );
  $sharing_icon_print = get_bodycommerce_option( 'sharing_icon_print' );
  $sharing_icon_whatsapp = get_bodycommerce_option( 'sharing_icon_whatsapp' );

  $sharing_icon_text_before_get = get_bodycommerce_option( 'sharing_icon_text_before' );
  do_action( 'wpml_register_single_string', 'divi-bodyshop-woocommerce', 'Sharing Icons Before Text', $sharing_icon_text_before_get );
  $sharing_icon_text_before = apply_filters( 'wpml_translate_single_string', $sharing_icon_text_before_get, 'divi-bodyshop-woocommerce', 'Sharing Icons Before Text' );


  if ($sharing_icon_style == "none") {}
  else {


    $css_woo_bodyshop =  '<style id="bodycommerce_sharing_icons">';
   $css_woo_bodyshop .= '


   .bodycommerce-link {
   padding: 2px 8px 4px 8px !important;
   color: '.$sharing_icon_btn_color.';
   font-size: 12px;
   border-radius: '.$sharing_icon_btn_border_radius.'px;
   margin-right: 5px;
   cursor: pointer;
   -moz-background-clip: padding;
   -webkit-background-clip: padding-box;
   box-shadow: inset 0 -3px 0 rgba(0,0,0,.2);
   -moz-box-shadow: inset 0 -3px 0 rgba(0,0,0,.2);
   -webkit-box-shadow: inset 0 -3px 0 rgba(0,0,0,.2);
   margin-top: 2px;
   display: inline-block;
   text-decoration: none;
   }

   .bodycommerce-link:hover,.bodycommerce-link:active {
   color: white;
   }

   .bodycommerce-twitter {
   background: #00aced;
   }

   .bodycommerce-twitter:hover,.bodycommerce-twitter:active {
   background: #0084b4;
   }

   .bodycommerce-facebook {
   background: #3B5997;
   }

   .bodycommerce-facebook:hover,.bodycommerce-facebook:active {
   background: #2d4372;
   }

   .bodycommerce-instagram {
    background: #f09433; 
    background: -moz-linear-gradient(45deg, #f09433 0%, #e6683c 25%, #dc2743 50%, #cc2366 75%, #bc1888 100%); 
    background: -webkit-linear-gradient(45deg, #f09433 0%,#e6683c 25%,#dc2743 50%,#cc2366 75%,#bc1888 100%); 
    background: linear-gradient(45deg, #f09433 0%,#e6683c 25%,#dc2743 50%,#cc2366 75%,#bc1888 100%); 
    filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f09433", endColorstr="#bc1888",GradientType=1 );
   }

   .bodycommerce-instagram:hover,  .bodycommerce-instagram:active {
    background: #f09433; 
    background: -moz-linear-gradient(45deg, #f09433 0%, #e6683c 25%, #dc2743 50%, #cc2366 75%, #bc1888 100%); 
    background: -webkit-linear-gradient(45deg, #f09433 0%,#e6683c 25%,#dc2743 50%,#cc2366 75%,#bc1888 100%); 
    background: linear-gradient(45deg, #f09433 0%,#e6683c 25%,#dc2743 50%,#cc2366 75%,#bc1888 100%); 
    filter: progid:DXImageTransform.Microsoft.gradient( startColorstr="#f09433", endColorstr="#bc1888",GradientType=1 );
   }

   .bodycommerce-pinterest {
   background: #bd081c;
   }

   .bodycommerce-pinterest:hover,.bodycommerce-pinterest:active {
   background: #9e0818;
   }

   .bodycommerce-email {
   background: #738a8d;
   }

   .bodycommerce-email:hover,.bodycommerce-email:active {
   background: #617375;
   }

   .bodycommerce-print {
   background: #20292f;
   }

   .bodycommerce-print:hover,.bodycommerce-print:active {
   background: #000000;
   }

   .bodycommerce-linkedin {
   background: #0074A1;
   }

   .bodycommerce-linkedin:hover,.bodycommerce-linkedin:active {
   background: #006288;
   }

   .bodycommerce-whatsapp {
   background: #43d854;
   }

   .bodycommerce-whatsapp:hover,.bodycommerce-whatsapp:active {
   background: #009688;
   }

   .bodycommerce-social {
   margin: 20px 0px 25px 0px;
   -webkit-font-smoothing: antialiased;
   font-size: 12px;
   }      ';

if ($sharing_icon_style == "icons") {
 $css_woo_bodyshop .= '

 /* icons */
 .bodycommerce-social.icons .bodycommerce-link {
   font-size: 0;
 box-shadow: none;
 -moz-box-shadow: none;
 -webkit-box-shadow: none;
 width: 35px;
 height: 35px;
 position: relative;
 }

 .bodycommerce-social.icons svg {
   display: block;
    height: 16px;
    width: 100%;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%,-50%);
    fill: '.$sharing_icon_btn_color.';
    z-index: 10;
  }

';
} else {
  $css_woo_bodyshop .= '
 
  .bodycommerce-social.icons svg {
    display: none;
   }
 
 ';
}

   $css_woo_bodyshop .= '</style>';
   //minify it
   $css_woo_bodyshop_min = str_replace( array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $css_woo_bodyshop );
   echo $css_woo_bodyshop_min;





global $post;
if ( is_single() ) {
$bodycommerceURL = urlencode(get_permalink());
$bodycommerceTitle = htmlspecialchars(urlencode(html_entity_decode(get_the_title(), ENT_COMPAT, 'UTF-8')), ENT_COMPAT, 'UTF-8');
$bodycommerceThumbnail = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
$twitterURL = 'https://twitter.com/intent/tweet?text='.$bodycommerceTitle.'&amp;url='.$bodycommerceURL.'';
$facebookURL = 'https://www.facebook.com/sharer/sharer.php?u='.$bodycommerceURL;
$whatsappURL = 'https://wa.me/?text='.$bodycommerceTitle . ' ' . $bodycommerceURL;
$linkedInURL = 'https://www.linkedin.com/shareArticle?mini=true&url='.$bodycommerceURL.'&amp;title='.$bodycommerceTitle;
$emailURL = 'mailto:?subject='.$sharing_icon_email_subject.' '.$bodycommerceTitle.'&amp;body='.$sharing_icon_email_body.' '.$bodycommerceURL;
// pinterest is about pictures and so, we add the media
if (isset($bodycommerceThumbnail[0])) {
$pinterestURL = 'https://pinterest.com/pin/create/button/?url='.$bodycommerceURL.'&amp;media='.$bodycommerceThumbnail[0].'&amp;description='.$bodycommerceTitle;
}

$sharinglinks .= '<div class="bodycommerce-social icons">';

$sharinglinks .= '<h5>'.$sharing_icon_text_before.'</h5>';

if ($sharing_icon_twitter == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-twitter" href="'. $twitterURL .'" target="_blank">Twitter<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M459.37 151.716c.325 4.548.325 9.097.325 13.645 0 138.72-105.583 298.558-298.558 298.558-59.452 0-114.68-17.219-161.137-47.106 8.447.974 16.568 1.299 25.34 1.299 49.055 0 94.213-16.568 130.274-44.832-46.132-.975-84.792-31.188-98.112-72.772 6.498.974 12.995 1.624 19.818 1.624 9.421 0 18.843-1.3 27.614-3.573-48.081-9.747-84.143-51.98-84.143-102.985v-1.299c13.969 7.797 30.214 12.67 47.431 13.319-28.264-18.843-46.781-51.005-46.781-87.391 0-19.492 5.197-37.36 14.294-52.954 51.655 63.675 129.3 105.258 216.365 109.807-1.624-7.797-2.599-15.918-2.599-24.04 0-57.828 46.782-104.934 104.934-104.934 30.213 0 57.502 12.67 76.67 33.137 23.715-4.548 46.456-13.32 66.599-25.34-7.798 24.366-24.366 44.833-46.132 57.827 21.117-2.273 41.584-8.122 60.426-16.243-14.292 20.791-32.161 39.308-52.628 54.253z"/></svg></a>';
}
if ($sharing_icon_facebook == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-facebook" href="'.$facebookURL.'" target="_blank">Facebook<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512"><path d="M279.14 288l14.22-92.66h-88.91v-60.13c0-25.35 12.42-50.06 52.24-50.06h40.42V6.26S260.43 0 225.36 0c-73.22 0-121.08 44.38-121.08 124.72v70.62H22.89V288h81.39v224h100.17V288z"/></svg></a>';
}
if ($sharing_icon_linkedin == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-linkedin" href="'.$linkedInURL.'" target="_blank">LinkedIn<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M100.28 448H7.4V148.9h92.88zM53.79 108.1C24.09 108.1 0 83.5 0 53.8a53.79 53.79 0 0 1 107.58 0c0 29.7-24.1 54.3-53.79 54.3zM447.9 448h-92.68V302.4c0-34.7-.7-79.2-48.29-79.2-48.29 0-55.69 37.7-55.69 76.7V448h-92.78V148.9h89.08v40.8h1.3c12.4-23.5 42.69-48.3 87.88-48.3 94 0 111.28 61.9 111.28 142.3V448z"/></svg></a>';
}
if ($sharing_icon_pinterest == 1 && isset($bodycommerceThumbnail[0])) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-pinterest" href="'.$pinterestURL.'" data-pin-custom="true" target="_blank">Pin it<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><path d="M204 6.5C101.4 6.5 0 74.9 0 185.6 0 256 39.6 296 63.6 296c9.9 0 15.6-27.6 15.6-35.4 0-9.3-23.7-29.1-23.7-67.8 0-80.4 61.2-137.4 140.4-137.4 68.1 0 118.5 38.7 118.5 109.8 0 53.1-21.3 152.7-90.3 152.7-24.9 0-46.2-18-46.2-43.8 0-37.8 26.4-74.4 26.4-113.4 0-66.2-93.9-54.2-93.9 25.8 0 16.8 2.1 35.4 9.6 50.7-13.8 59.4-42 147.9-42 209.1 0 18.9 2.7 37.5 4.5 56.4 3.4 3.8 1.7 3.4 6.9 1.5 50.4-69 48.6-82.5 71.4-172.8 12.3 23.4 44.1 36 69.3 36 106.2 0 153.9-103.5 153.9-196.8C384 71.3 298.2 6.5 204 6.5z"/></svg></a>';
}
if ($sharing_icon_whatsapp == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-whatsapp" href="'.$whatsappURL.'" target="_blank">Whatsapp<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M380.9 97.1C339 55.1 283.2 32 223.9 32c-122.4 0-222 99.6-222 222 0 39.1 10.2 77.3 29.6 111L0 480l117.7-30.9c32.4 17.7 68.9 27 106.1 27h.1c122.3 0 224.1-99.6 224.1-222 0-59.3-25.2-115-67.1-157zm-157 341.6c-33.2 0-65.7-8.9-94-25.7l-6.7-4-69.8 18.3L72 359.2l-4.4-7c-18.5-29.4-28.2-63.3-28.2-98.2 0-101.7 82.8-184.5 184.6-184.5 49.3 0 95.6 19.2 130.4 54.1 34.8 34.9 56.2 81.2 56.1 130.5 0 101.8-84.9 184.6-186.6 184.6zm101.2-138.2c-5.5-2.8-32.8-16.2-37.9-18-5.1-1.9-8.8-2.8-12.5 2.8-3.7 5.6-14.3 18-17.6 21.8-3.2 3.7-6.5 4.2-12 1.4-32.6-16.3-54-29.1-75.5-66-5.7-9.8 5.7-9.1 16.3-30.3 1.8-3.7.9-6.9-.5-9.7-1.4-2.8-12.5-30.1-17.1-41.2-4.5-10.8-9.1-9.3-12.5-9.5-3.2-.2-6.9-.2-10.6-.2-3.7 0-9.7 1.4-14.8 6.9-5.1 5.6-19.4 19-19.4 46.3 0 27.3 19.9 53.7 22.6 57.4 2.8 3.7 39.1 59.7 94.8 83.8 35.2 15.2 49 16.5 66.6 13.9 10.7-1.6 32.8-13.4 37.4-26.4 4.6-13 4.6-24.1 3.2-26.4-1.3-2.5-5-3.9-10.5-6.6z"/></svg></a>';
}
if ($sharing_icon_email == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-email" href="'.$emailURL.'" target="_blank">Email<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M48 64C21.5 64 0 85.5 0 112c0 15.1 7.1 29.3 19.2 38.4L236.8 313.6c11.4 8.5 27 8.5 38.4 0L492.8 150.4c12.1-9.1 19.2-23.3 19.2-38.4c0-26.5-21.5-48-48-48H48zM0 176V384c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V176L294.4 339.2c-22.8 17.1-54 17.1-76.8 0L0 176z"/></svg></a>';
}
if ($sharing_icon_print == 1) {
$sharinglinks .= '<a class="bodycommerce-link bodycommerce-print" href="#" onclick="window.print();" target="_blank">Print<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M128 0C92.7 0 64 28.7 64 64v96h64V64H354.7L384 93.3V160h64V93.3c0-17-6.7-33.3-18.7-45.3L400 18.7C388 6.7 371.7 0 354.7 0H128zM384 352v32 64H128V384 368 352H384zm64 32h32c17.7 0 32-14.3 32-32V256c0-35.3-28.7-64-64-64H64c-35.3 0-64 28.7-64 64v96c0 17.7 14.3 32 32 32H64v64c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V384zm-16-88c-13.3 0-24-10.7-24-24s10.7-24 24-24s24 10.7 24 24s-10.7 24-24 24z"/></svg></a>';
}

$sharinglinks .= '</div>';
echo $sharinglinks;
} else {
// if not a post/page then don't include sharing button
echo $sharinglinks;
} }
}
add_filter( 'woocommerce_share', 'bodycommerce_social_sharing_buttons');
 ?>
